/*
 * Proyecto: treeviewmod
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 13/05/2020
 */

#include "Xailer.ch"
#include "Directry.ch"


CLASS TForm1 FROM TForm

  METHOD LoadFiles( cDir )

   COMPONENT oTree
  COMPONENT oBevel1
   COMPONENT oEditMod1
  COMPONENT oBrowseForFolderDlg1
  COMPONENT oStatusBar1
   COMPONENT oButtonMod1
   COMPONENT oButtonMod2

  METHOD CreateForm()
  METHOD EditMod1BtnClick( oSender, nX, nY )
  METHOD FormInitialize( oSender )
  METHOD TreeGetTooltipText( oSender, oItem, @cText )
   METHOD ButtonMod1Click( oSender )
   METHOD ButtonMod2Click( oSender )

ENDCLASS

#include "Form1.xfm"


//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TForm1

  IF !Empty( ::oEditMod1:Value )
    ::LoadFiles( ::oEditMod1:Value )
  ENDIF

RETURN NIL

//------------------------------------------------------------------------------

METHOD EditMod1BtnClick( oSender, nX, nY ) CLASS TForm1

  WITH OBJECT ::oBrowseForFolderDlg1
    :cRoot := ::oEditMod1:Value
    IF :Run()
      ::oEditMod1:Value := :cRoot
      ::LoadFiles( :cRoot )
    ENDIF
  END WITH

RETURN NIL

//------------------------------------------------------------------------------

METHOD LoadFiles( cDir ) CLASS TForm1

  LOCAL oItem
  LOCAL nFiles

  Application:lbusy := .T.

  ::oTree:BeginPaint()

  ::oTree:DeleteItems()

  IF !Empty( cDir )
    oItem := ::oTree:AddItem( cDir, 1, 1, .t. )
    AddFiles( oItem, cDir )
  ENDIF

  nFiles := ::oTree:GetCount()

  IF nFiles > 0
    ::oStatusBar1:cText := LTrim( Transform( nFiles, "999,999,999" ) ) + " files"
    //::oTree:ExpandAll()
    ::oTree:SelectRoot()
  ENDIF

  ::oTree:EndPaint()

  Application:lbusy := .F.

RETURN NIL

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

STATIC FUNCTION AddFiles( oParent, cDir )

  LOCAL oItem
  LOCAL aDir, aFile
  LOCAL cFile
  LOCAL nImg

  aDir := Directory( cDir + "\*.*" )
  nImg := 3

  ASort( aDir,,, {| x, y | Upper( x[ 1 ] ) < Upper( y[ 1 ] ) } )

  FOR EACH aFile IN aDir
    cFile := aFile[ F_NAME ]
    WITH OBJECT oParent:AddItem( cFile, nImg, nImg, .t. , clBlue )
      :Cargo := cDir + "\" + cFile
    END WITH
   if ++nImg > 5
      nImg := 3
   ENDIF
  NEXT

  aDir := Directory( cDir + "\*.*", "D" )

  ASort( aDir,,, {| x, y | Upper( x[ 1 ] ) < Upper( y[ 1 ] ) } )

  FOR EACH aFile IN aDir
    cFile := aFile[ F_NAME ]
    IF "D" $ aFile[ F_ATTR ] .AND. cFile != "." .AND. cFile != ".."
      WITH OBJECT oParent:AddItem( cFile, 2, 2,.t., clRed )
        AddFiles( :__WithObject(), cDir + "\" + cFile )
      END WITH
    ENDIF
  NEXT

RETURN NIL

//------------------------------------------------------------------------------

METHOD TreeGetTooltipText( oSender, oItem, cText ) CLASS TForm1

  WITH OBJECT oItem
    IF !Empty( :Cargo )
      cText := :Cargo + "\" + :cText
    ENDIF
  END WITH

RETURN Nil

//------------------------------------------------------------------------------

METHOD ButtonMod1Click( oSender ) CLASS TForm1

   local aItems

   aItems := ::oTree:GetAllItems()

   AEval( aItems, {|o| o:cText := Upper( o:cText ) } )

RETURN Nil

//------------------------------------------------------------------------------

METHOD ButtonMod2Click( oSender ) CLASS TForm1

   with object TForm2():New( Self )
      :Create()
      :ShowModal()
   end with

RETURN Nil

//------------------------------------------------------------------------------
